unit Keoegrid;
{
Sorry to English the speaking people. There was no time for a translation. But
you will find a sample application attached. So I'm sure it won't take long
you make a good acquaintance with the component.

Extended StringGrid:
- Align cells contents
- Variable fonts per cell
- Insert, replace, delete complete lines
- Edit header line at design time
- Sort of Columns by string, int, float, . . .
- Protect cells, columns, rows
- Hide Columns and rows
- Komfortable access by keyboard!
- SaveToFile and LoadFromFile methods

Some lines below we make a little publicity for our Btrieve Components for
Delphi. Those Components don't throw out the BDE. Everything is complete
for comfortable Delphi-Btrieve developping. We do it all day long and are
building large applications with it. Edits, Grid, Navigator, visual Report
designer ...

--------------------------------------------------------------------------------
    Komponente TKeoEGrid - Extended Grid                  Stand Mai 1998
--------------------------------------------------------------------------------

Die Komponente ist eine Erweiterung von TStringGrid. Fr ein elegantes Arbeiten
fehlen dort meiner Ansicht nach noch einige Mglichkeiten. Einen Teil dieser
enthlt nun TKeoEGrid. Die ersten zwei Features (Variable Ausrichtung und Farben
hab' ich mir der Einfachheit halber erlaubt, aus der (ebenfalls Freeware)-
Komponente TStgrExt von Gerd Bernau (CIS 100121,3322) zu bernehmen.
Wenn ich etwas Zeit habe (haha), werde ich das Ganze noch erweitern (Validation,
vielleicht rechnen usw.). Wenn mir jemand andere gute Ideen zukommen lt, die
von allgemeinem Interesse sind, arbeite ich diese evtl. auch ein. Email- bzw.
Faxnummer stehen weiter unten im Kasten.
Wer wei - vielleicht kommt mal das eierlegende Wollmilch-Grid heraus? (Obwohl
das Eierlegen dabei vielleicht nicht eine so ganz gute Idee ist ...)

Zur Registrierung die Prozedur 'entklammern' und die gewnschte Palettenseite
eintragen (ca. Zeile 850 und ganz hinten).

- Ausrichtung des Zellinhaltes links-, rechtsbndig oder zentriert (GB).
- Schriftfarbe der Zellen variabel setzbar (GB).
- Einfgen ganzer Zeilen ber eine Prozedur mit offenem Array.
- Ersetzen ganzer Zeilen ber eine Prozedur mit offenem Array.
- Einfgen von Leerzeilen.
- Lschen ganzer Zeilen.
- Grid bis auf Titelzeile leeren.
- Spaltenberschriften knnen schon im Design-Modus gesetzt werden.
- Sortierung nach beliebiger Spalte in String-, Integer-, Float-,
  Datum- oder Zeit-Logik.
- Eigene Zellen-Sperrlogik fr Zeilen, Spalten und einzelne Zellen
  (nicht ber SelectCell ntig).
- Komfortable Bedienung auch o h n e Maus fr nchste, vorige, obere, untere
  Zelle: gesperrte Zellen/Spalten/Zeilen werden bersprungen.
  (Warum wird unter Windows die Tastatur immer vergessen ?!).
- Mehrzeiliges Bespringen der Zellen mit Tastatur an-/abschaltbar.
- Spalten knnen versteckt/wieder aktiviert werden
- Methoden SaveToFile und LoadFromFile
- Eigene Hilfe zu jeder Spalte (property Hints)

 ------------------------------------------------------------------------------
|        Freeware, Quellcode bitte unverndert weitergeben. Viel Spass.        |
|        Einziges Anliegen:  Lest auch das, was nun anschlieend steht!        |
|         ber Tips und Verbesserungsvorschlge wrde ich mich freuen!         |
|         Martin Danesch (KEOPS GmbH,  A-9020 Klagenfurt, Schloweg 6)         |
|   email: keops@carinthia.com   Tel: +43 463 41130   Fax: +43 463 41130-14    |
 ------------------------------------------------------------------------------

Ein wenig Werbung mchten wir aber doch auch machen fr einiges was wir sonst
noch anbieten knnen (Diese Dinge haben wir zwar auch fr uns selbst gemacht,
daher praxisnah, sind aber etwas lnger daran gesessen, daher keine Freeware,
Preise stehen dabei):

* KEOBTV Umfangreiche Datenbankanbindung von Btrieve in Delphi, wobei die BDE
  erhalten bleibt. Mit eigenen visuellen Komponenten, Grid, Tools uvm.):
  - Sehr leistungsfhige Methoden zum Datenbankhandling, bis hin zu Loops,
    Increment etc.,
  - Datensatzmanipulation (erster, nchster, voriger, letzter Datensatz) per
    Tastendruck in den vis. Komponenten integriert,
  - Automatische Umschaltung erfassen/ndern nach Eingabe des kompletten Key,
    sowohl beim Grid als auch bei den Edit-Komponenten,
  - Gleiche Fhigkeiten der Editfelder wie die KEOEDIT-Komponenten (siehe unten)
  - Optische Gstaltungsmglichkeiten beim Grid,
  - Eigenes Data Dictionary, das Import/Export von Original-DDFs beherrscht,
    sowie Data Dictionarys von WIZDOM (DOS) bernehmen kann,
  - Tool zur direkten bernahme der Felder, Indexnamen und Datenbankbefehle
    in den Quellcode,
  - Tabellengenerator,
  - Automatische Synchronisation mehrerer Formulare einer Applikation, die die
    gleiche Tabelle verwenden,
  - natrlich ein Datenbanknavigator
  - und ... und ... und ...
    Gibt es auch als Sharewareversion zum Probieren (KEOBTV.ZIP). Einschrnkung
    ist lediglich, da max. 5 Tabellen erstellt werden knnen.
    DEM 695,- (Vollversion inkl. Handbuch, und Delphi-integrierbarer Hilfe)

* KEOEDIT: Ein Satz von Edit-Feldern, die ...
  - links-, rechtsbndig und zentriert darstellen knnen,
  - ein OnValidate-Ereignis aufweisen, das auch funktioniert, wenn nur
    ein Eingabefeld im Formular ist,
  - einen Label automatisch generieren und dann synchronisieren (verschieben,
    Visible, Font usw.),
  - verschiedene Vorgaben fr die Darstellung haben (Eingabefeld, Anzeigefeld,
    hervorgehobenes Eingabefeld, hervorgehobenes Anzeigefeld usw.),
  - formatiert ausgeben knnen (Gruppierung, Whrung etc.),
  - direkt mit den Datentypen Integer, Float, Date, Time arbeiten,
  - bei den Date- und Time-Komponenten eine sehr vereinfachte Eingabe haben
    (nur Tag oder Tag und Monat, nicht komplettes Datum/Zeit ntig),
  - viel resourcensparender als Edit-Felder sind (auch hunderte pro Formular
    seinerzeit unter Windows 3.n kein Problem)!
    DEM 95,- (inkl. Handbuch, und Delphi-integrierbarer Hilfe)

* KEOFUNC: Eine Sammlung von ber 60 Funktionen und Prozeduren, die die
  alltgliche Arbeit erleichtern sollen. Unter anderem:
  - Check ob ein Formular oder eine MDI-Instanz vorhanden ist.
  - Krzen eines String auf bestimmte Lnge und drei Punkte (Windows95...),
  - Check ob eine Taste gerade gedrckt ist (Fein f.'Shift' bei KeyPressed),
  - Float in Dreiergruppierung als String ausgeben,
  - 3er-gruppierten Dezimalwert in einerm String in ein Float umwandeln,
  - Text diagonal in beliebigem Winkel in ein Canvas zeichnen,
  - Prfung, ob sich zwei Linien schneiden,
  - Animierten Cursor statt Stundenglas starten/stoppen,
  - Menpunkte hinzufgen/entfernen,
  - Bit-Manipulationen,
  - Programm starten mit Warten auf Beedigung,
  - Textbreite in Pixeln ermitteln,
  - Bei programmiertem erzeugen einer Komponente Prfung, ob Name vorhanden,
    wenn ja um 1, 2 usw. erweitern,
  - Kalenderwoche aus Datum ermitteln,
  - Eigenes MessageDlg mit anderer Optik und der Mglichkeit, vorzugeben,
    welche Taste default ist!!
  - Fernsteuern einer Listbox,
  - und noch ber 60 mehr.
    DEM 45,- (inkl. Handbuch, und Delphi-integrierbarer Hilfe)

* KEOPRINT: Reportgenerator einer anderen Art:
  - Sehr schnell,
  - Kann sowohl BDE- als auch KEOBTV-(KEOPS Btrieve fr Delphi) Komponenten
    verarbeiten (lediglich TBTVTable- oder TTable-Komponente auf das Formular
    ziehen und schon stehen alle Felder zur Verfgung),
  - WYSIWYG-Design in externem Programm: Der Anwender kann sich seine Reports
    selbst gestalten, aber trotzdem neue Versionen deiner Programme bekommen!
  - Steuerung direkt in Delphi mit wenigen Handgriffen einzubinden, daher
    keine Ladezeiten,
  - Druckvorschau,
  - Auch komplexeste Reports lassen sich bewltigen! Zig logische Zeilenarten
    knnen vergeben werden, fr aufwendigste Gruppenwechsel usw.
    Es sind keine Sub-Reports notwendig.
    DEM 595,- (inkl. Handbuch, und Delphi-integrierbarer Hilfe)

* Bundle KEOBTV + KEOEDIT + KEOFUNC + KEOPRINT: DEM 1195,-

REVISION HISTORY
01.09.97/DD - SkipToNextRow=False wurde nicht ausgewertet, wenn man in der ersten freien
              Spalte gestanden ist und <Pfeil links> prete.
21.09.97/DD - SelectACell verschiebt den entsprechenden Bildschirmbereich so nach unten
              oder oben, da die selektierte Zelle auch sichtbar ist.
            - Bei OnDrawCell die ererbte Methode ermglicht.
28.09.97/DD - Fehler bei DelLines behoben.
01.02.98/DD - Methoden RepaintCell, RepaintRow, RepaintCol sind dazugekommen.
17.04.98/DD - Methoden SaveToFile und LoadFromFile sind neu dazugekommen.
16.05.98/DD - Hints pro Spalte.
}

interface

uses
  SysUtils, WinTypes, WinProcs, Messages, Classes, Graphics, Controls,
  Forms, Dialogs, Grids;

type
  TSortObj = class
    S: TStringList;
    constructor Create;
    destructor Destroy; override;
  end;

  TGridSortMode = (gsmString, gsmInteger, gsmFloat, gsmDate, gsmTime, gsmDateTime);

  TGetDrawValues = procedure(Sender: TObject;col,row:integer;var aFont:tFont;
                               var aAlignment:TAlignment; var bgColor: TColor) of object;

  TKeoEGrid = class(TStringGrid)
  private
    FAlignment:TAlignment;
    FGetDrawValues:TGetDrawValues;
    FHeader: TStringList;
    FHints: TStringList;
    FLastKey: Word;
    FSkipToNextRow: Boolean;
    FOldCol: Longint;
    FOldRow: Longint;
    FLockedCols: TStringList;
    FLockedRows: TStringList;
    FLockedCells: TStringList;
    FHiddenCols: TStringList;
  protected
    procedure DrawHeader;
    procedure ValsToCells(Row: Longint; const Vals: array of string);
    procedure Loaded; override;
    procedure SetAlignment(avalue:TAlignment);
    procedure DoGetDrawValues(col, row: integer; var aFont: tFont; var aAlignment: TAlignment;
              var bgColor: TColor); virtual;
    procedure SetHeader(Value: TStringList);
    procedure SetHints(Value: TStringList);
    procedure Sort(ACol, ACol2: Longint; Mode: TGridSortMode; Decs: Integer);
    procedure SkipRightCell(ACol, ARow: Longint);
    procedure SkipLeftCell(ACol, ARow: Longint);
    procedure SkipUpCell(ACol, ARow: Longint);
    procedure SkipDownCell(ACol, ARow: Longint);
    procedure AssignHints(Col: Integer);
  public
    constructor Create(AOwner: TComponent); override;
    destructor Destroy; override;
    procedure DrawCell(Col, Row: Longint; Rect: TRect; State: TGridDrawState); override;
    procedure KeyDown(var Key: Word; Shift: TShiftState); override;
    procedure MouseDown(Button: TMouseButton; Shift: TShiftState;
              X, Y: Integer); override;
    function SelectCell(ACol, ARow: Longint): Boolean; override;
    function Select1Cell(ACol, ARow: Integer): Boolean;
    function SelectACell(ACol, ARow: Integer): Boolean;
    function LineEmpty(Row: Integer): Boolean;
    procedure AddLine(const Vals: array of string);
    procedure InsertLine(Behind: Longint; const Vals: array of string);
    procedure ReplaceLine(Line: Longint; const Vals: array of string);
    procedure InsertEmptyLines(Behind, Count: Longint);
    procedure DelLines(Row, Count: Longint);
    procedure Clear;
    procedure SortAsString(ACol: Longint);
    procedure SortAsInteger(ACol: Longint);
    procedure SortAsFloat(ACol: Longint; Decs: Integer);
    procedure SortAsDate(ACol: Longint);
    procedure SortAsTime(ACol: Longint);
    procedure SortAsDateTime(ACol, AColT: Longint);
    procedure LockCol(ACol: Longint);
    procedure LockRow(ARow: Longint);
    procedure LockCell(ACol, ARow: Longint);
    procedure UnLockCol(ACol: Longint);
    procedure UnLockRow(ARow: Longint);
    procedure UnLockCell(ACol, ARow: Longint);
    function IsColLocked(ACol: Longint): Boolean;
    function IsRowLocked(ARow: Longint): Boolean;
    function IsCellLocked(ACol, ARow: Longint): Boolean;
    procedure HideCol(ACol: Longint);
    procedure ShowCol(ACol: Longint);
    function IsColHidden(ACol: Longint): Boolean;
    procedure RePaintCell(ACol, ARow: Longint);
    procedure RePaintRow(ARow: Longint);
    procedure RePaintCol(ACol: Longint);
    procedure SaveToFile(FileName: string);
    procedure LoadFromFile(FileName: string);
  published
    property Alignment:TAlignment read FAlignment write SetAlignment default taleftjustify;
    property OnGetDrawValues:TGetDrawValues read FGetDrawValues write FGetDrawValues;
    property Header: TStringList  read FHeader  write SetHeader;
    property Hints: TStringList  read FHints  write SetHints;
    property SkipToNextRow: Boolean  read FSkipToNextRow  write FSkipToNextRow default True;
 end;

function Extract(S: string; Po: Integer; T: string): String;
function Str3ToFloat(Input: string): Extended;


{procedure Register;}

implementation



function Extract(S: string; Po: Integer; T: string): String;
var I,P: Integer;
    St: string;
begin
  St := S;
  if Po <> 0 then
  for I := 1 to Po do
  begin
    P := Pos(T,St);
    Delete(St,1,P);
  end;
  Delete(St,Pos(T,St),Length(St)-Pos(T,St)+1);
  Result := St;
end;

function Str3ToFloat(Input: string): Extended;
var S: string;
    I: Integer;
    Negativ: Integer;
  function IsZiffer(Zi: Integer): Boolean;
  begin
    Result := (Zi >= 0) and (Zi <= 9);
  end;
begin
  Negativ := 1;
  S := Input;
  if (Pos('-', S) <> 0) and IsZiffer(StrToInt(S[Pos('-', S)+1])) then Negativ := -1;
  I := 1;
  while I <= Length(S) do
    if (S[I] <> ',') and ((Ord(S[I]) < 48) or (Ord(S[I]) > 57)) then Delete(S, I, 1)
    else Inc(I);
  if S = '' then S := '0';
  if Pos(',', S) = 1 then Insert('0', S, 1);
  Result := StrToFloat(S) * Negativ;
end;




{========================================================================================}
{---------------------------------------TSortObj-----------------------------------Create}
constructor TSortObj.Create;
begin
  inherited Create;
  S := TStringList.Create;
end;

{---------------------------------------TSortObj----------------------------------Destroy}
destructor TSortObj.Destroy;
begin
  S.Free;
  inherited Destroy;
end;


{========================================================================================}
{---------------------------------------TKeoEGrid----------------------------------Create}
constructor TKeoEGrid.Create(AOwner: TComponent);
begin
  inherited Create(AOwner);
  FHeader := TStringList.Create;
  FHints := TStringList.Create;
  FLockedCols := TStringList.Create;
  FLockedRows := TStringList.Create;
  FLockedCells := TStringList.Create;
  FHiddenCols := TStringList.Create;
  FSkipToNextRow := True;
end;

{---------------------------------------TKeoEGrid----------------------------------Loaded}
procedure TKeoEGrid.Loaded;
begin
  inherited Loaded;
  DrawHeader;
end;


{---------------------------------------TKeoEGrid---------------------------------Destroy}
destructor TKeoEGrid.Destroy;
begin
  FHeader.Free;
  FHints.Free;
  FLockedCols.Free;
  FLockedRows.Free;
  FLockedCells.Free;
  FHiddenCols.Free;
  inherited Destroy;
end;

{---------------------------------------TKeoEGrid------------------------------DrawHeader}
procedure TKeoEGrid.DrawHeader;
var I: Integer;
begin
  for I := 0 to FHeader.Count-1 do
    if I < ColCount then Cells[I,0] := FHeader[I];
end;

{---------------------------------------TKeoEGrid-----------------------------ValsToCells}
procedure TKeoEGrid.ValsToCells(Row: Longint; const Vals: array of string);
var I: Integer;
begin
  for I := Low(Vals) to High(Vals) do
    if I < ColCount then Cells[I,Row] := Vals[I];
end;


{---------------------------------------TKeoEGrid----------------------------SetAlignment}
procedure TKeoEGrid.SetAlignment(avalue:TAlignment);
  begin
   FAlignment:=avalue;
   invalidate;
  end;

{---------------------------------------TKeoEGrid-------------------------------SetHeader}
procedure TKeoEGrid.SetHeader(Value: TStringList);
begin
  FHeader.Assign(Value);
  DrawHeader;
end;

{---------------------------------------TKeoEGrid--------------------------------SetHints}
procedure TKeoEGrid.SetHints(Value: TStringList);
begin
  FHints.Assign(Value);
end;

{---------------------------------------TKeoEGrid-------------------------doGetDrawValues}
procedure TKeoEGrid.DoGetDrawValues(col, row: integer; var aFont: tFont; var aAlignment: TAlignment;
          var bgColor: TColor);
begin
  if assigned(FGetDrawValues) then FGetDrawValues(@self, col, row, aFont, aAlignment, bgColor);
end;

{---------------------------------------TKeoEGrid--------------------------------DrawCell}
procedure TKeoEGrid.DrawCell(Col, Row: Longint; Rect: TRect; State: TGridDrawState);
var
  aWidth:integer;
  bAlignment:tAlignment;
  bFont:tFont;
  bgColor: TColor;
begin
  bAlignment := FAlignment;
  bFont      := Canvas.Font;
  bgColor    := Canvas.Brush.Color;

  doGetDrawValues(col, row, bFont, bAlignment, bgColor);

  Canvas.Font := bFont;
  Canvas.Pen.Color := Canvas.Brush.Color;
  Canvas.Pen.Color := Canvas.Brush.Color;
  Canvas.Brush.Color := bgColor;
  aWidth := Canvas.TextWidth(Cells[Col, Row]);
  Canvas.Rectangle(Rect.Left, Rect.Top, Rect.Right, Rect.Bottom);
  case bAlignment of
    taLeftJustify : Canvas.TextRect(Rect, Rect.Left+2,rect.top+2,cells[col,row]);
    taCenter      : Canvas.TextRect(Rect, Rect.Left+(rect.right-rect.left) div
                    2-aWidth div 2,Rect.Top+2,cells[col,row]);
    taRightJustify: Canvas.TextRect(Rect, Rect.Right-aWidth-2,Rect.Top+2,Cells[Col,Row]);
  end;
  if Assigned(OnDrawCell) then inherited;
end;


{---------------------------------------TKeoEGrid---------------------------------KeyDown}
procedure TKeoEGrid.KeyDown(var Key: Word; Shift: TShiftState);
begin
  FLastKey := Key;
  FOldCol := Col;
  FOldRow := Row;
  if (Key = VK_RIGHT) and (Col = ColCount-1) and (Row < RowCount-1) and SkipToNextRow then
  begin
    if IsCellLocked(FixedCols, Row+1) then SkipRightCell(FixedCols, Row+1)
    else SelectACell(FixedCols, Row+1);
    Key := 0;
  end
  else if (Key = VK_LEFT) and (Col = FixedCols) and (Row > FixedRows) and SkipToNextRow then
  begin
    if IsCellLocked(ColCount-1, Row-1) then SkipLeftCell(ColCount-1, Row-1)
    else SelectACell(ColCount-1, Row-1);
    Key := 0;
  end;
  inherited KeyDown(Key, Shift);
end;


{---------------------------------------TKeoEGrid-------------------------------MouseDown}
procedure TKeoEGrid.MouseDown(Button: TMouseButton; Shift: TShiftState; X, Y: Integer);
begin
  FLastKey := 0;
  inherited MouseDown(Button, Shift, X, Y);
end;


{---------------------------------------TKeoEGrid------------------------------SelectCell}
function TKeoEGrid.SelectCell(ACol, ARow: Longint): Boolean;
begin
  Result := not IsCellLocked(ACol, ARow);
  if (not Result) and (FLastKey <> 0) then
  begin
    case FLastKey of
      VK_RIGHT: SkipRightCell(ACol, ARow);
      VK_LEFT:  SkipLeftCell(ACol, ARow);
      VK_DOWN:  SkipDownCell(ACol, ARow);
      VK_UP:    SkipUpCell(ACol, ARow);
    end;
  end;
  inherited SelectCell(ACol, ARow);

  AssignHints(ACol);
end;

{---------------------------------------TKeoEGrid---------------------------SkipRightCell}
procedure TKeoEGrid.SkipRightCell(ACol, ARow: Longint);
var C,R: Longint;
    Found: Boolean;
    MaxRow: Longint;
begin
  C := ACol;
  R := ARow;
  Found := False;
  if SkipToNextRow then MaxRow := RowCount-1 else MaxRow := ARow;
  while (not Found) and ((C+1 <= ColCount) and (R <= MaxRow)) do
  begin
    if IsCellLocked(C, R) then
    begin
      if C = ColCount-1 then begin Inc(R); C := 0; end
      else Inc(C);
    end
    else Found := True;
    if Found then Select1Cell(C, R)
    else Select1Cell(FOldCol, FOldRow);
  end;
end;



{---------------------------------------TKeoEGrid----------------------------SkipLeftCell}
procedure TKeoEGrid.SkipLeftCell(ACol, ARow: Longint);
var C,R: Longint;
    Found: Boolean;
    MinRow: Longint;
begin
  C := ACol;
  R := ARow;
  Found := False;
  if SkipToNextRow then MinRow := FixedRows else MinRow := ARow;
  while (not Found) and ((C >= FixedCols) and (R >= MinRow)) do
  begin
    if IsCellLocked(C, R) then
    begin
      if C = FixedCols then begin Dec(R); C := ColCount-1; end
      else Dec(C);
    end
    else Found := True;
    if Found then Select1Cell(C, R)
    else Select1Cell(FOldCol, FOldRow);
  end;
end;

{---------------------------------------TKeoEGrid----------------------------SkipDownCell}
procedure TKeoEGrid.SkipDownCell(ACol, ARow: Longint);
var C,R: Longint;
    Found: Boolean;
    PrevCell, NextCell: Longint;
    LastRow: Longint;
begin
  C := ACol;
  R := ARow;
  Found := False;
  if SkipToNextRow then LastRow := RowCount-1 else LastRow := ARow;
  while (R <= LastRow) and (not Found) do
  begin
    PrevCell := C;
    while (PrevCell > FixedCols) and (IsCellLocked(PrevCell,R)) do Dec(PrevCell);
    NextCell := C;
    while (NextCell < ColCount-1) and (IsCellLocked(NextCell,R)) do Inc(NextCell);
    if IsCellLocked(PrevCell,R) then PrevCell := NextCell;
    if IsCellLocked(NextCell,R) then NextCell := PrevCell;
    if (PrevCell = ColCount-1) and (NextCell = ColCount-1) and IsCellLocked(ColCount-1,R) then Inc(R)
    else
    begin
      if NextCell-ACol <= Abs(ACol+PrevCell) then C := NextCell
      else C := PrevCell;
      Found := True;
    end;
  end;
  if Found then Select1Cell(C, R)
  else Select1Cell(FOldCol, FOldRow);
end;


{---------------------------------------TKeoEGrid------------------------------SkipUpCell}
procedure TKeoEGrid.SkipUpCell(ACol, ARow: Longint);
var C,R: Longint;
    Found: Boolean;
    PrevCell, NextCell: Longint;
    FirstRow: Longint;
begin
  C := ACol;
  R := ARow;
  Found := False;
  if SkipToNextRow then FirstRow := FixedRows else FirstRow := ARow;
  while (R >= FirstRow) and (not Found) do
  begin
    PrevCell := C;
    while (PrevCell > FixedCols) and (IsCellLocked(PrevCell,R)) do Dec(PrevCell);
    NextCell := C;
    while (NextCell < ColCount-1) and (IsCellLocked(NextCell,R)) do Inc(NextCell);
    if IsCellLocked(PrevCell,R) then PrevCell := NextCell;
    if IsCellLocked(NextCell,R) then NextCell := PrevCell;
    if (PrevCell = ColCount-1) and (NextCell = ColCount-1) and IsCellLocked(ColCount-1,R) then Dec(R)
    else
    begin
      if NextCell-ACol <= Abs(ACol+PrevCell) then C := NextCell
      else C := PrevCell;
      Found := True;
    end;
  end;
  if Found then Select1Cell(C, R)
  else Select1Cell(FOldCol, FOldRow);
end;

{---------------------------------------TKeoEGrid-----------------------------AssignHints}
procedure TKeoEGrid.AssignHints(Col: Integer);
begin
  if Col < FHints.Count then
  begin
    Hint := Hints[Col];
    Perform(CM_SHOWHINTCHANGED, 0, 0);
  end;
end;

{---------------------------------------TKeoEGrid-----------------------------Select1Cell}
function TKeoEGrid.Select1Cell(ACol, ARow: Integer): Boolean;
var R: TGridRect;
begin
  Result := False;
  if (ACol < FixedCols) or (ACol > ColCount) then Exit;
  if (ARow < FixedRows) or (ARow > RowCount) then Exit;
  R.Left   := ACol;
  R.Top    := ARow;
  R.Right  := ACol;
  R.Bottom := ARow;
  Selection := R;
end;


{---------------------------------------TKeoEGrid-----------------------------SelectACell}
function TKeoEGrid.SelectACell(ACol, ARow: Integer): Boolean;
var R: TGridRect;
begin
  Result := False;
  if (ACol < FixedCols) or (ACol > ColCount) then Exit;
  if (ARow < FixedRows) or (ARow > RowCount) then Exit;
  if IsCellLocked(ACol, ARow) then Exit;
  R.Left   := ACol;
  R.Top    := ARow;
  R.Right  := ACol;
  R.Bottom := ARow;
  Selection := R;
  if ARow - TopRow > VisibleRowCount then TopRow := ARow - VisibleRowCount + 1;
  if ARow < TopRow then TopRow := ARow - 1;
  Result := True;

  AssignHints(ACol);
end;



{---------------------------------------TKeoEGrid-------------------------------LineEmpty}
function TKeoEGrid.LineEmpty(Row: Integer): Boolean;
var I: Integer;
begin
  Result := True;
  for I := 0 to ColCount-1 do if Cells[I, Row] <> '' then Result := False;
end;

{---------------------------------------TKeoEGrid---------------------------------AddLine}
procedure TKeoEGrid.AddLine(const Vals: array of string);
begin
  if (RowCount > FixedRows) and LineEmpty(FixedRows) then ReplaceLine(FixedRows, Vals)
  else
  begin
    RowCount := RowCount+1;
    ValsToCells(RowCount-1, Vals);
  end;
end;

{---------------------------------------TKeoEGrid------------------------------InsertLine}
procedure TKeoEGrid.InsertLine(Behind: Longint; const Vals: array of string);
begin
  if (Behind < FixedRows) then Exit
  else if Behind > ColCount-2 then AddLine(Vals)
  else
  begin
    InsertEmptyLines(Behind, 1);
    ValsToCells(Behind+1, Vals);
  end;
end;

{---------------------------------------TKeoEGrid-----------------------------ReplaceLine}
procedure TKeoEGrid.ReplaceLine(Line: Longint; const Vals: array of string);
begin
  ValsToCells(Line, Vals);
end;


{---------------------------------------TKeoEGrid------------------------InsertEmptyLines}
procedure TKeoEGrid.InsertEmptyLines(Behind, Count: Longint);
var I, J: Longint;
begin
  RowCount := RowCount+Count;
  for J := RowCount-1 downto Behind+Count+1 do
    for I := 0 to ColCount-1 do Cells[I, J] := Cells[I, J-Count];
  for J := Behind+1 to Behind+Count do
    for I := 0 to ColCount-1 do Cells[I, J] := '';
end;


{---------------------------------------TKeoEGrid--------------------------------DelLines}
procedure TKeoEGrid.DelLines(Row, Count: Longint);
var I, J: Integer;
begin
  if Row < FixedRows then Exit;
  if Row > RowCount-1 then Exit;
  if Row+Count > RowCount then Exit;
  for J := Row to RowCount-Count-1 do
    for I := 0 to ColCount-1 do Cells[I, J] := Cells[I, J+Count];
  RowCount := RowCount-Count;
end;


{---------------------------------------TKeoEGrid-----------------------------------Clear}
procedure TKeoEGrid.Clear;
var I: Integer;
begin
  for I := 0 to ColCount-1 do Cols[I].Clear;
  RowCount := FixedRows+1;
  DrawHeader;
end;



{---------------------------------------TKeoEGrid------------------------------------Sort}
procedure TKeoEGrid.Sort(ACol, ACol2: Longint; Mode: TGridSortMode; Decs: Integer);
var L: TStringList;
    I, J: Longint;
    So: TSortObj;
    Offset: Integer;
    SortVal: string;
    IntF: Integer;
    FloF: Extended;
begin
  L := TStringList.Create;
  Offset := FixedRows;
  try
    for I := 0+FixedRows to RowCount-1 do
    begin
      So := TSortObj.Create;
      for J := 0 to ColCount-1 do So.S.Add(Cells[J,I]);
      case Mode of
        gsmString:  Sortval := Cells[ACol, I];
        gsmInteger: begin
                      if Cells[ACol, I] = '' then IntF := 0
                      else IntF := StrToInt(Cells[ACol, I]);
                      Str(IntF:15, SortVal);
                    end;
        gsmFloat:   begin
                      if Cells[ACol, I] = '' then FloF := 0
                      else FloF := Str3ToFloat(Cells[ACol, I]);
                      Str(FloF:15:Decs, SortVal);
                    end;
        gsmDate:    begin
                      if Cells[ACol, I] = '' then FloF := 0
                      else FloF := StrToDate(Cells[ACol, I]);
                      Str(FloF:7:0, SortVal);
                    end;
        gsmTime:    begin
                      if Cells[ACol, I] = '' then FloF := 0
                      else FloF := StrToTime(Cells[ACol, I]);
                      Str(FloF:6:4, SortVal);
                    end;
        gsmDateTime:begin
                      if Cells[ACol, I] = '' then FloF := 0
                      else FloF := StrToDate(Cells[ACol, I]);
                      if Cells[ACol2, I] <> '' then FloF := Flof + StrToTime(Cells[ACol2, I]);
                      Str(FloF:11:4, SortVal);
                    end;
      end;
      L.AddObject(SortVal, So);
    end;
    L.Sorted := True;
    Clear;
    for I := 0 to L.Count-1 do
    begin
      if not LineEmpty(FixedRows) then RowCount := RowCount+1;
      with L.Objects[I] as TSortObj do
      begin
        for J := 0 to ColCount-1 do Cells[J, I+Offset] := S[J];
      end;
    end;
  finally
    for I := 0 to L.Count-1 do L.Objects[I].Free;
    L.Free;
  end;
end;


{---------------------------------------TKeoEGrid----------------------------SortAsString}
procedure TKeoEGrid.SortAsString(ACol: Longint);
begin
  Sort(ACol, 0, gsmString, 0);
end;
{---------------------------------------TKeoEGrid---------------------------SortAsInteger}
procedure TKeoEGrid.SortAsInteger(ACol: Longint);
begin
  Sort(ACol, 0, gsmInteger, 0);
end;
{---------------------------------------TKeoEGrid-----------------------------SortAsFloat}
procedure TKeoEGrid.SortAsFloat(ACol: Longint; Decs: Integer);
begin
  Sort(ACol, 0, gsmFloat, Decs);
end;
{---------------------------------------TKeoEGrid------------------------------SortAsDate}
procedure TKeoEGrid.SortAsDate(ACol: Longint);
begin
  Sort(ACol, 0, gsmDate, 0);
end;
{---------------------------------------TKeoEGrid------------------------------SortAsTime}
procedure TKeoEGrid.SortAsTime(ACol: Longint);
begin
  Sort(ACol, 0, gsmTime, 0);
end;
{---------------------------------------TKeoEGrid--------------------------SortAsDateTime}
procedure TKeoEGrid.SortAsDateTime(ACol, AColT: Longint);
begin
  Sort(ACol, AColT, gsmDateTime, 0);
end;


{---------------------------------------TKeoEGrid---------------------------------LockCol}
procedure TKeoEGrid.LockCol(ACol: Longint);
begin
  if not IsColLocked(ACol) then FLockedCols.Add(IntToStr(ACol));
end;
{---------------------------------------TKeoEGrid---------------------------------LockRow}
procedure TKeoEGrid.LockRow(ARow: Longint);
begin
  if not IsRowLocked(ARow) then FLockedRows.Add(IntToStr(ARow));
end;
{---------------------------------------TKeoEGrid--------------------------------LockCell}
procedure TKeoEGrid.LockCell(ACol, ARow: Longint);
begin
  if not IsCellLocked(ACol, ARow) then FLockedCells.Add(IntToStr(ACol) + ',' + IntToStr(ARow))
  else if isRowLocked(ARow) or isColLocked(ACol) then
    Application.MessageBox('Bereits ganze Zeile/Spalte gesperrt!', 'Information', MB_OK);
end;

{---------------------------------------TKeoEGrid-------------------------------UnLockCol}
procedure TKeoEGrid.UnLockCol(ACol: Longint);
var Idx: Longint;
begin
  Idx := FLockedCols.IndexOf(IntToStr(ACol));
  if Idx > -1 then FLockedCols.Delete(Idx);
end;
{---------------------------------------TKeoEGrid-------------------------------UnLockRow}
procedure TKeoEGrid.UnLockRow(ARow: Longint);
var Idx: Longint;
begin
  Idx := FLockedRows.IndexOf(IntToStr(ARow));
  if Idx > -1 then FLockedRows.Delete(Idx);
end;
{---------------------------------------TKeoEGrid------------------------------UnLockCell}
procedure TKeoEGrid.UnLockCell(ACol, ARow: Longint);
var Idx: Longint;
begin
  Idx := FLockedCells.IndexOf(IntToStr(ACol) + ',' + IntToStr(ARow));
  if (Idx > -1) then FLockedCells.Delete(Idx)
  else if isRowLocked(ARow) or isColLocked(ACol) then
   Application.MessageBox('ganze Zeile/Spalte gesperrt!', 'Information', MB_OK);
end;

{---------------------------------------TKeoEGrid-----------------------------IsColLocked}
function TKeoEGrid.IsColLocked(ACol: Longint): Boolean;
begin
  Result := FLockedCols.IndexOf(IntToStr(ACol)) > -1;
end;
{---------------------------------------TKeoEGrid-----------------------------IsRowLocked}
function TKeoEGrid.IsRowLocked(ARow: Longint): Boolean;
begin
  Result := FLockedRows.IndexOf(IntToStr(ARow)) > -1;
end;
{---------------------------------------TKeoEGrid----------------------------IsCellLocked}
function TKeoEGrid.IsCellLocked(ACol, ARow: Longint): Boolean;
begin
  Result := (FLockedCells.IndexOf(IntToStr(ACol) + ',' + IntToStr(ARow)) > -1) or
            (IsColLocked(ACol)) or
            (IsRowLocked(ARow));
end;


{---------------------------------------TKeoEGrid---------------------------------HideCol}
procedure TKeoEGrid.HideCol(ACol: Longint);
begin
  if not IsColHidden(ACol) then
  begin
    FHiddenCols.AddObject(IntToStr(ACol), Pointer(ColWidths[ACol]));
    LockCol(ACol);
    ColWidths[ACol] := 0;
  end;
end;

{---------------------------------------TKeoEGrid---------------------------------ShowCol}
procedure TKeoEGrid.ShowCol(ACol: Longint);
var Idx: Longint;
begin
  Idx := FHiddenCols.IndexOf(IntToStr(ACol));
  if Idx > -1 then
  begin
    ColWidths[ACol] := Longint(FHiddenCols.Objects[Idx]);
    UnlockCol(ACol);
    FHiddenCols.Delete(Idx);
  end;
end;

{---------------------------------------TKeoEGrid-----------------------------IsColHidden}
function TKeoEGrid.IsColHidden(ACol: Longint): Boolean;
begin
  Result := FHiddenCols.IndexOf(IntToStr(ACol)) > -1;
end;

{---------------------------------------TKeoEGrid-----------------------------RePaintCell}
procedure TKeoEGrid.RePaintCell(ACol, ARow: Longint);
var R: TRect;
begin
  R := CellRect(ACol, ARow);
  InvalidateRect((Owner as TForm).Handle, @R, True);
end;

{---------------------------------------TKeoEGrid------------------------------RePaintRow}
procedure TKeoEGrid.RePaintRow(ARow: Longint);
var R, R1: TRect;
begin
  R := CellRect(0, ARow);
  R1 := CellRect(ColCount-1, ARow);
  R.Right := R1.Right;
  InvalidateRect(Self.Handle, @R, False);
end;

{---------------------------------------TKeoEGrid------------------------------RePaintCol}
procedure TKeoEGrid.RePaintCol(ACol: Longint);
var R, R1: TRect;
begin
  R := CellRect(ACol, 0);
  R1 := CellRect(ACol, RowCount-1);
  R.Bottom := R1.Bottom;
  InvalidateRect(Self.Handle, @R, False);
end;

{---------------------------------------TKeoEGrid------------------------------SaveToFile}
procedure TKeoEGrid.SaveToFile(FileName: string);
var I, J: Integer;
    F: TextFile;
    S: string;
begin
  AssignFile(F, FileName);
  ReWrite(F);
  for I := 1 to RowCount-1 do
  begin
    S := '';
    for J := 0 to ColCount-1 do S := S + Cells[J, I] + #7;
    Writeln(F, S);
  end;
  CloseFile(F);
end;

{---------------------------------------TKeoEGrid----------------------------LoadFromFile}
procedure TKeoEGrid.LoadFromFile(FileName: string);
var I: Integer;
    Io: Integer;
    F: TextFile;
    S: string;
begin
  Clear;
  AssignFile(F, FileName);
  {$I-}
  ReSet(F);
  {$I+}
  Io := IoResult;
  If Io = 0 then
  begin
    while not Eof(F) do
    begin
      ReadLn(F, S);
      AddLine(['']);
      for I := 0 to ColCount-1 do Cells[I, RowCount-1] := Extract(S, I, #7);
    end;
    CloseFile(F);
  end;
end;




{========================================================================================}
{
procedure Register;
begin
  RegisterComponents('Keops II', [TKeoEGrid]);
end;
}

end.
